#include <stdio.h>
#include <stdlib.h>
#include "bellmanford.h"

int main()
{
  unsigned int numnode, numedge, numpi, numpo, pi, po, u, v, t, p, i, num, fail;
  float w, *d;
//  FILE *fp;
//  fp=fopen("testfileneg","rb");
  graph_t *E = graph_create();
  edge_t *edge, **Adj;
  info_t *info;

  scanf("%d%d%d%d", &numnode, &numedge, &numpi, &numpo);
  num = numnode + 1;
  if ((Adj = (edge_t **)malloc(num*sizeof(edge_t *))) == NULL) no_mem_exit();
  if ((d = (float *)calloc(num, sizeof(float))) == NULL) no_mem_exit();

  for (i=1; i<=numnode; i++) 
    Adj[i] = 0;
  for (i=0; i<numpi; i++) 
    scanf("%d", &pi);
  for (i=0; i<numpo; i++) 
    scanf("%d", &po);

  for (i=0; i<numedge; i++) {
    scanf("%d%d%f%d%d", &u, &v, &w, &t, &p);
    if ((info = (struct info *)calloc(1, sizeof(struct info))) == NULL) no_mem_exit();
    info->t = t;
    info->p = p;
    info->w = w;
    edge = graph_add_edge(E, u, v, (void *)info);
    graph_adjacent(Adj, edge);
  }

  fail = bellmanford(numnode, Adj, d);      
  if (fail == 0)  
    for (i=1; i<=numnode; i++) 
      printf("d[%d]=%f\n", i, d[i]);      
  else printf("Negative Cycle!\n");
  graph_free(E);
  free(Adj);
  free(d);

  return 0;
}  
