#include <stdlib.h>
#include <math.h>
#include "dijkstra_int.h"

void
dijkstra(unsigned int numnode, graph_t *E, fibheap_t *fh, 
	 float *dij, unsigned int s, edge_t **Adj)
{
  unsigned int i, u, v;
  fibheap_node *node, **nodeid;  
  edge_t *edge;  
  data_t *data;
  if ((nodeid = (fibheap_node **)calloc(numnode+1, sizeof(fibheap_node *))) == NULL) no_mem_exit();
  
  for (i=1; i<=numnode; i++) 
    dij[i] = P_INFINITY;
  dij[s] = 0;
  for (i=1; i<=numnode; i++) {
    if ((data = (data_t *)calloc(1, sizeof(data_t))) == NULL) no_mem_exit();
    data->v = &dij[i];
    data->id = i;
    node = fibheap_insert(fh, (void *) data);
    nodeid[i] = node;
  }
  while (fibheap_size(fh)>0) {
    data = (data_t *)fibheap_extract_min(fh);
//    for (i=1;i<=numnode;i++)
//      fibheap_check(nodeid[i]);
    if (*(data->v) < P_INFINITY/2) { 
      u = data->id;
      edge = Adj[u];
      while (edge) {
	v = edge->en;
        if ((dij[v]- dij[u]- ((info_t *)edge->info)->w) > EPSI){
          dij[v] = dij[u]+((info_t *)edge->info)->w;
	  fibheap_decrease_key(fh, nodeid[v], 
			       fibheap_node_get_data(nodeid[v]));
//          for (i=1;i<=numnode;i++)
//	    fibheap_check(nodeid[i]);	  
	}
        edge = edge->nextadj;
      }
    } else
      fibheap_reset(fh); 
    free(data);
  }
  
  free(nodeid);
}

