#include <stdio.h>
#include <stdlib.h>
#include "dijkstra.h"
#include "dijkstra_int.h"

static float 
compare(void *data1, void *data2)
{
  float tmp;
  tmp = *(((data_t *)data1)->v) - *(((data_t *)data2)->v);
  return tmp;
} 
    
static void 
free_fcn(void *data)
{   
  free(data); 
}   


int main()
{
  unsigned int numnode, numedge, numpi, numpo, pi, po, 
    u, v, t, p, i, j, num;
  float w, *dij, neg=NEGINFINITY;
//  FILE *fp;
  graph_t *E = graph_create();
  edge_t *edge, **Adj;
  info_t *info;

  data_t *data;
  data = (data_t *)calloc(1, sizeof(data_t));
  data->v = &neg;
  data->id = 0;
  fibheap_t *fh = fibheap_create(compare, data);

//  fp=fopen("/home/clin/benchmark/ISCAS89/TRANSLATOR/testfile","rb");
  scanf("%d%d%d%d", &numnode, &numedge, &numpi, &numpo);

  num = numnode + 1;
  if ((Adj = (edge_t **)malloc(num*sizeof(edge_t *))) == NULL) no_mem_exit();
  
  for (i=1; i<=numnode; i++) 
    Adj[i] = 0;

  for (i=0; i<numpi; i++) {
    scanf("%d", &pi);
  }
  for (i=0; i<numpo; i++) {
    scanf("%d", &po);
  }
  for (i=0; i<numedge; i++) {
    scanf("%d%d%f%d%d", &u, &v, &w, &t, &p);
    if ((info = (struct info *)calloc(1, sizeof(struct info))) == NULL) no_mem_exit();
    info->w = w;
    info->t = t;
    info->p = p;
    edge = graph_add_edge(E, u, v, (void *)info);
    graph_adjacent(Adj, edge);
  }

  if ((dij = (float *)calloc(num, sizeof(float))) == NULL) no_mem_exit();

  for (i=1; i<=numnode; i++) { 
    dijkstra(numnode, E, fh, dij, i, Adj);
    if (i==1) {
      for (j=1;j<=numnode;j++)
        printf("d[%d][%d]=%f\n", i, j, dij[j]);
    }
  }

  fibheap_free(fh, free_fcn);
  graph_free(E);
  free(Adj);
  free(dij);
  return 0;
}  
