#include <stdio.h>
#include <stdlib.h>
#include "fibheap.h"
#include "fibheap_int.h"

typedef struct data{
   float *v;
   int id;
} data_t;

static float 
compare(void *data1, void *data2)
{
  float tmp;
  tmp =  *(((data_t *)data1)->v) - *(((data_t *)data2)->v);
  return tmp;
}


static void
free_fcn(void *data)
{
  printf("delete %f\n", *(((data_t *)data)->v));
  free(data);
}

static void
no_mem_exit()
{
  printf("No memory.\n");
  exit(1);
}

int main()
{
  int num, num1, i;
  float *x, *y, *z, neg = NEGINFINITY;
  fibheap_node *node1, *node2;
  data_t *data;
 
  data = (data_t *)calloc(1, sizeof(data_t));
  data->v = &neg;
  data->id = 0;
 
  fibheap_t *fh1 = fibheap_create(compare, data);
  fibheap_t *fh2 = fibheap_create(compare, data);
  FILE *fp;

  fp = fopen("/home/clin/src/fibheap/testfile","rb");
  fscanf(fp, "%d", &num);
  num1 = num + 1;
  if ((x = (float *)calloc(num1, sizeof(float))) == NULL) no_mem_exit();
  if ((y = (float *)calloc(num1, sizeof(float))) == NULL) no_mem_exit();
  if ((z = (float *)calloc(num1, sizeof(float))) == NULL) no_mem_exit();

  for (i=0; i<num; i++) {
    fscanf(fp, "%f%f", &x[i], &y[i]);
    data = (data_t *)calloc(1, sizeof(data_t));
    data->v = &x[i];
    data->id = i;
    node1 = fibheap_insert(fh1,(void *) data);
    data = (data_t *)calloc(1, sizeof(data_t));
    data->v = &y[i];
    data->id = i;
    node2 = fibheap_insert(fh2,(void *) data);
    if (i%4 == 1) {
      printf("%f,", *(((data_t *)fibheap_min(fh1))->v));
      data = (data_t *)calloc(1, sizeof(data_t));
      z[i]=x[i]-5;
      data->v = &z[i];
      data->id = i;
      fibheap_decrease_key(fh1, node1, (void *)data);
    } else if (i%4 == 3) {
      printf("%f\n", *(((data_t *)fibheap_min(fh2))->v));
      
      printf("delete %f\n", *(((data_t *)fibheap_node_get_data(node2))->v));
      fibheap_delete(fh2, node2);
    }
  }
  fibheap_union(fh1, fh2);
  printf("\nextract_min:\n");
  while (fibheap_size(fh1) > 4) {
    data = (data_t *)fibheap_extract_min(fh1);
    printf("%f\n", *(data->v));
    free(data);
  }
  
  fibheap_free(fh1, free_fcn);
  free(x);
  free(y);
  free(z);
  fclose(fp);
  return 0;
}


