#ifndef FIBHEAP_H
#define FIBHEAP_H

#define NEGINFINITY -1000

typedef struct heap fibheap_t;
typedef struct node fibheap_node;

typedef float (*fibheap_cmp)(void *data1, void *data2);
typedef void (*fibheap_free_fcn)(void *data);

extern fibheap_t *fibheap_create(fibheap_cmp cmp, void *data);
extern void fibheap_free(fibheap_t *h, fibheap_free_fcn f);

extern unsigned int fibheap_size(fibheap_t *h);
extern fibheap_node *fibheap_insert(fibheap_t *h, void *data);
extern void fibheap_union(fibheap_t *h1, fibheap_t *h2);
extern void *fibheap_extract_min(fibheap_t *h);
extern void *fibheap_extract_min_not_free(fibheap_t *h);
extern void *fibheap_min(fibheap_t *h);
extern void fibheap_decrease_key(fibheap_t *h, fibheap_node *x, void *data);
extern void fibheap_delete(fibheap_t *h, fibheap_node *x);
extern void *fibheap_node_get_data(fibheap_node *node);
extern void fibheap_check(fibheap_node *node);
extern void fibheap_reset(fibheap_t *h);
extern void fibheap_insert_node(fibheap_t *h, fibheap_node *node);

#endif
