#ifndef GRAPH_H
#define GRAPH_H

typedef struct graph graph_t;
typedef struct edge edge_t;

extern graph_t *graph_create();
extern void graph_free(graph_t *g);
extern void graph_freeedges(graph_t *g);

extern void graph_append_edge(graph_t *g, edge_t *edge);
extern void graph_append_edgepi(graph_t *g, edge_t *edge);
extern edge_t *graph_make_edge(unsigned int sn, unsigned int en, void *info);
extern edge_t *graph_add_edge(graph_t *g, unsigned int sn, unsigned int en, void *info);
extern void graph_adjacent(edge_t **Adj, edge_t *edge);
extern void graph_adjacent_en(edge_t **Adj, edge_t *edge);
extern void graph_adjacent_pi(edge_t **piAdj, edge_t *edge);
extern void set_make(unsigned int p[], unsigned int rank[], unsigned int x);
extern unsigned int set_find(unsigned int p[], unsigned int x);
extern void set_link(unsigned int p[], unsigned int rank[], unsigned int x, unsigned int y);
extern void set_union(unsigned int p[], unsigned int rank[], unsigned int x, unsigned int y);
extern void no_mem_exit();

#endif
