#include <stdio.h>
#include <stdlib.h>
#include "mcrp_int.h"

int main()
{
  unsigned int numnode, numedge, u, v, t, p, i, maxormin;
  float w, lamda = 0;
  graph_t *E = graph_create();
  edge_t *edge;
  info_t *info;

  scanf("%d%d", &numnode, &numedge);
  for (i=0; i<numedge; i++) {
    scanf("%d%d%f%d%d", &u, &v, &w, &t, &p);
    if ((info = (struct info *)calloc(1, sizeof(struct info))) == NULL) no_mem_exit();
    info->w = w;
    info->t = t;
    info->p = p;
    edge = graph_add_edge(E, u, v, (void *)info);
  }
 
  maxormin = 0;   // 0 for max cycle; 1 for min cycle
  mcrp_compute(numnode, E, &lamda, maxormin);
  if (lamda < P_INFINITY/2) {
    if (maxormin)
      printf("\nmin cycle ratio: %f\n", lamda);
    else printf("\nmax cycle ratio: %f\n", lamda); 
  }
  else printf("No Cycle Found!\n");
  graph_free(E);
  
  return 0;
}  
